#  -*- coding: UTF-8 -*-

# MindPlus
# Python
import base64
from io import BytesIO
from PIL import Image
import random
import time
import siot
import cv2


siot.init(client_id="",server="127.0.0.1",port=1883,user="siot",password="dfrobot")
siot.connect()
siot.loop()

def frame2base64(frame):
    frame = cv2.cvtColor(frame, cv2.COLOR_BGR2RGB)
    img = Image.fromarray(frame) #将每一帧转为Image
    output_buffer = BytesIO() #创建一个BytesIO
    img.save(output_buffer, format='JPEG') #写入output_buffer
    byte_data = output_buffer.getvalue() #在内存中读取
    base64_data = base64.b64encode(byte_data) #转为BASE64
    return base64_data #转码成功 返回base64编码

def base642base64(frame):
    data=str('data:image/png;base64,')
    base64data = str(frame2base64(frame))
    framedata = base64data[2:(len(base64data)-1)]
    base642base64_data = data + str(framedata)
    return base642base64_data
YiNianJiRenShu = 101
ErNianJiRenShu = 102
SanNianJiRenShu = 103
SiNianJiRenShu = 104
WuNianJiRenShu = 105
LiuNianJiRenShu = 106
ZongRenShu = (YiNianJiRenShu + (ErNianJiRenShu + (SanNianJiRenShu + (SiNianJiRenShu + (WuNianJiRenShu + LiuNianJiRenShu)))))
siot.getsubscribe(topic="siot/通知")
siot.getsubscribe(topic="siot/当前时间")
siot.getsubscribe(topic="siot/图像")
siot.getsubscribe(topic="siot/今日人数")
siot.getsubscribe(topic="siot/雨量")
siot.getsubscribe(topic="siot/风向")
siot.getsubscribe(topic="siot/风速")
siot.getsubscribe(topic="siot/光线")
siot.getsubscribe(topic="siot/音量")
siot.getsubscribe(topic="siot/湿度")
siot.getsubscribe(topic="siot/温度")
siot.getsubscribe(topic="siot/气压")
siot.getsubscribe(topic="siot/天气")
siot.getsubscribe(topic="siot/一年级人数")
siot.getsubscribe(topic="siot/二年级人数")
siot.getsubscribe(topic="siot/三年级人数")
siot.getsubscribe(topic="siot/四年级人数")
siot.getsubscribe(topic="siot/五年级人数")
siot.getsubscribe(topic="siot/六年级人数")
for index in range(10):
    time.sleep(3)
    siot.publish_save(topic="siot/一年级人数", data=YiNianJiRenShu)
    siot.publish_save(topic="siot/二年级人数", data=ErNianJiRenShu)
    siot.publish_save(topic="siot/三年级人数", data=SanNianJiRenShu)
    siot.publish_save(topic="siot/四年级人数", data=SiNianJiRenShu)
    siot.publish_save(topic="siot/五年级人数", data=WuNianJiRenShu)
    siot.publish_save(topic="siot/六年级人数", data=LiuNianJiRenShu)
    siot.publish_save(topic="siot/通知", data="今日通知：XXX")
    siot.publish_save(topic="siot/当前时间", data=time.strftime("%Y/%m/%d %H:%M:%S"))
    siot.publish_save(topic="siot/天气", data="今日天气：")
    img = cv2.imread('22331.jpg ') 
    siot.publish_save(topic="siot/图像", data=base642base64(img))
    siot.publish_save(topic="siot/今日人数", data=ZongRenShu)
    siot.publish_save(topic="siot/雨量", data=(random.randint(55, 75)))
    siot.publish_save(topic="siot/风向", data="东南")
    siot.publish_save(topic="siot/风速", data=(random.randint(0, 12)))
    siot.publish_save(topic="siot/光线", data=(random.randint(55, 3000)))
    siot.publish_save(topic="siot/音量", data=(random.randint(0, 65)))
    siot.publish_save(topic="siot/湿度", data=round((random.uniform(30, 75)),2))
    siot.publish_save(topic="siot/温度", data=round((random.uniform(-10, 40)),2))
    siot.publish_save(topic="siot/气压", data=(random.uniform(1000, 1200)))
